# ---------------------------------------------------------------------------
.deploy_script: &deploy_script |
  cat <<\EOF >> deploy/deploy.bash
  #!/bin/bash

  ENVIRONMENT=${CI_ENVIRONMENT_SLUG}
  ENVIRONMENT=$(echo $ENVIRONMENT | tr '[:lower:]' '[:upper:]')

  if [ ! -z $ENVIRONMENT ]; then
    echo 'environment:' $ENVIRONMENT;
    vars=($(compgen -v $ENVIRONMENT))
    # Override environment specific settings
    for name in "${vars[@]}"; do
      echo 'use override variable' $name;
      override=$(echo ${name//$ENVIRONMENT'_'});
      echo $override;
      export $override="${!name}";
      unset $name;
    done;
  fi

  export CI_ENVIRONMENT_HOSTNAME="$(echo $CI_ENVIRONMENT_URL | sed 's~http[s]*://~~g')"

  BASEDIR=$(dirname "$0")
  mkdir $BASEDIR/.generated

  for f in $BASEDIR/*.yml
  do
    echo $f;
    envsubst < $f > "./deploy/.generated/$(basename $f)"
    if [[ $DEBUG ]]; then
      cat "./deploy/.generated/$(basename $f)";
    fi
  done

  rancher login ${RANCHER_API} --token ${RANCHER_TOKEN} --context ${RANCHER_CONTEXT}

  APP_ID=$(rancher apps | grep -o '.*:'$RELEASE_NAME)

  if [ -z "$CHART_VERSION" ]; then
    echo "Auto use latest chart version"
    CHART_VERSION=$(rancher apps st $CHART | tail -1)
  fi

  if [[ $APP_ID ]]; then
    echo "Upgrade app $APP_ID"
    if [[ $ONLY_UPDATE_IMAGE ]]; then
      rancher app upgrade --set image.repository=${CI_REGISTRY_IMAGE} --set image.tag=${CI_COMMIT_TAG} ${APP_ID} ${CHART_VERSION}
    else
      rancher app upgrade --values ${VALUES_FILE} ${APP_ID} ${CHART_VERSION}
    fi
  else
    echo "Install app"
    rancher app install --no-prompt --namespace ${KUBE_NAMESPACE} --values ${VALUES_FILE} --version ${CHART_VERSION} ${CHART} ${RELEASE_NAME}
  fi

  EOF
# ---------------------------------------------------------------------------
.deploy: &deploy
  stage: deploy
  image:
    name: registry.gitlab.com/krachtonline/docker/rancher-cli:c57c877
    entrypoint: ["/bin/sh","-c"]
  variables:
    CHART: blackholegalaxy/rancher-cli:2.2.0-1
    VALUES_FILE: ./deploy/.generated/values.yml
    RELEASE_NAME: $CI_PROJECT_NAME-$CI_ENVIRONMENT_SLUG
  script:
    - wget https://storage.googleapis.com/kubernetes-release/release/v1.14.1/bin/linux/amd64/kubectl -P /usr/local/bin
    - chmod +x /usr/local/bin/kubectl
    - apk update
    - apk add bash gettext
    - *deploy_script
    - bash ./deploy/deploy.bash
# ---------------------------------------------------------------------------

deploy:
  <<: *deploy
  only:
    - tags
    - triggers
  environment:
    name: production
deploy-staging:
  <<: *deploy
  only:
    - staging
  environment:
    name: staging
  before_script:
    - echo -e "machine gitlab.com\nlogin gitlab-ci-token\npassword ${CI_JOB_TOKEN}" > ~/.netrc
    - export CI_COMMIT_TAG=staging
